=== modified file 'annotate/gannotate.py'
--- annotate/gannotate.py	2007-09-14 15:56:39 +0000
+++ annotate/gannotate.py	2007-09-15 14:42:19 +0000
@@ -44,13 +44,13 @@
 class GAnnotateWindow(gtk.Window):
     """Annotate window."""
 
-    def __init__(self, all=False, plain=False):
+    def __init__(self, all=False, plain=False, parent=None):
         self.all = all
         self.plain = plain
+        self._parent = parent
         
         gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
 
-        self.connect("delete-event", gtk.main_quit)
         self.connect("key-press-event", self._on_key_pressed)
         
         self.set_icon(self.render_icon(gtk.STOCK_FIND, gtk.ICON_SIZE_BUTTON))
@@ -404,6 +404,8 @@
     def _on_key_press_w(self, event):
         if event.state & gtk.gdk.CONTROL_MASK:
             self.destroy()
+            if self._parent is None:
+                gtk.main_quit()
 
     def _on_key_press_q(self, event):
         if event.state & gtk.gdk.CONTROL_MASK:

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2007-09-14 08:40:45 +0000
+++ olive/__init__.py	2007-09-15 14:42:19 +0000
@@ -679,7 +679,7 @@
         branch = self.wt.branch
         file_id = self.wt.path2id(self.wt.relpath(os.path.join(self.path, self.get_selected_right())))
         
-        window = GAnnotateWindow(all=False, plain=False)
+        window = GAnnotateWindow(all=False, plain=False, parent=self.window)
         window.set_title(os.path.join(self.path, self.get_selected_right()) + " - Annotate")
         config = GAnnotateConfig(window)
         window.show()
@@ -742,7 +742,7 @@
     
     def on_menuitem_stats_log_activate(self, widget):
         """ Statistics/Log... menu handler. """
-        window = branchwin.BranchWindow()
+        window = branchwin.BranchWindow(parent=self.window)
         if not self.remote:
             window.set_branch(self.wt.branch, self.wt.branch.last_revision(), None)
         else:

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2007-09-14 15:56:39 +0000
+++ viz/branchwin.py	2007-09-15 14:42:19 +0000
@@ -26,12 +26,14 @@
     for a particular branch.
     """
 
-    def __init__(self):
+    def __init__(self, parent=None):
         gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
         self.set_border_width(0)
         self.set_title("bzrk")
 
-        self.connect("delete-event", gtk.main_quit)
+        self._parent = parent
+
+        self.connect('key-press-event', self._on_key_pressed)
 
         # Use three-quarters of the screen by default
         screen = self.get_screen()
@@ -47,8 +49,6 @@
         self.accel_group = gtk.AccelGroup()
         self.add_accel_group(self.accel_group)
 
-        self.connect('key-press-event', self._on_key_pressed)
-
         self.construct()
 
     def construct(self):
@@ -214,6 +214,8 @@
     def _on_key_press_w(self, event):
         if event.state & gtk.gdk.CONTROL_MASK:
             self.destroy()
+            if self._parent is None:
+                gtk.main_quit()
 
     def _on_key_press_q(self, event):
         if event.state & gtk.gdk.CONTROL_MASK:

